unit ReplaysUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls;

type
  TReplaysForm = class(TForm)
    WatchButton: TButton;
    Button2: TButton;
    ReplaysListBox: TListBox;
    ReloadButton: TSpeedButton;
    RichEdit1: TRichEdit;
    Label1: TLabel;
    PlayersListBox: TListBox;
    PlayersLabel: TLabel;
    Label3: TLabel;
    MapLabel: TLabel;
    Label4: TLabel;
    GameTypeLabel: TLabel;
    DeleteButton: TSpeedButton;
    Label2: TLabel;
    SizeLabel: TLabel;

    function LoadReplay(Index: Integer): Boolean;

    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ReloadButtonClick(Sender: TObject);
    procedure ReplaysListBoxClick(Sender: TObject);
    procedure WatchButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ReplaysForm: TReplaysForm;

implementation

uses Unit1, StrUtils, ShellAPI, BattleFormUnit, Misc;

{$R *.dfm}

procedure TReplaysForm.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TReplaysForm.FormCreate(Sender: TObject);
begin
  ReloadButton.OnClick(nil);
end;

procedure TReplaysForm.ReloadButtonClick(Sender: TObject);
begin
  MainForm.EnumerateReplayList;
  ReplaySListBox.Items.Assign(ReplayList);
  if ReplaysListBox.Items.Count = 0 then
  begin
    RichEdit1.Lines.Clear;
    WatchButton.Enabled := False;
    DeleteButton.Enabled := False;
  end
  else
  begin
    ReplaysListBox.ItemIndex := 0;
    ReplaysListBoxClick(nil);
    WatchButton.Enabled := True;
    DeleteButton.Enabled := True;
  end;
end;

function TReplaysForm.LoadReplay(Index: Integer): Boolean;
var
  f: file of byte;
  c: char;
  i, j, k: integer;
  count: Integer;
  s: string;
  su: string;
begin
  Result := False;
  RichEdit1.Lines.Clear;
  PlayersListBox.Items.Clear;
  MapLabel.Caption := '?';
  GameTypeLabel.Caption := '?';
  SizeLabel.Caption := '?';
  PlayersLabel.Caption := 'Players:';
  if Index > ReplaysListBox.Count-1 then Exit;

  AssignFile(f, ExtractFilePath(Application.ExeName) + 'demos\' + ReplaysListBox.Items[ReplaysListBox.ItemIndex]);

  {$I+}
  try
    Reset(f);

    BlockRead(f, c, 1);
    if Ord(c) <> 1 then
    begin
      CloseFile(f);
      Exit;
    end;
    BlockRead(f, i, 4);

    SetLength(s, i);
    BlockRead(f, s[1], i);
    RichEdit1.Lines.Add(s);

    su := UpperCase(s);

    count := 0;
    while True do
    begin
      i := Pos('[PLAYER' + IntToStr(count), su);
      if i = 0 then Break;

      j := PosEx('NAME=', su, i);
      if j = 0 then Break;
      j := j + 5;
      k := PosEx(';', su, j);
      if k = 0 then Break;
      PlayersListBox.Items.Add(Copy(s, j, k-j));

      Inc(count);
    end;
    PlayersLabel.Caption := 'Players (' + IntToStr(count) + '):';

    i := Pos('MAPNAME=', su);
    i := i + 8;
    j := PosEx(';', su, i);
    if (i<>0) and (j<>0) then MapLabel.Caption := Copy(s, i, j-i);

    i := Pos('GAMETYPE=', su);
    i := i + 9;
    j := PosEx(';', su, i);
    if (i<>0) and (j<>0) then GameTypeLabel.Caption := Copy(s, i, j-i);

    SizeLabel.Caption := Misc.FormatFileSize(FileSize(f)) + ' KB';

    CloseFile(f);
  except
    try
      CloseFile(f);
    except
    end;

    Exit;
  end;

  Result := True;
end;

procedure TReplaysForm.ReplaysListBoxClick(Sender: TObject);
begin
   if not LoadReplay(ReplaysListBox.ItemIndex) then
   begin
     RichEdit1.Lines.Clear;
     RichEdit1.Lines.Add('Outdated/corrupt demo file format!')
   end;
end;

procedure TReplaysForm.WatchButtonClick(Sender: TObject);
begin
  if BattleForm.IsBattleActive then
  begin
    MessageDlg('Disconnect from battle first!', mtWarning, [mbOK], 0);
    Exit;
  end;

  ShellExecute(MainForm.Handle, nil, 'spring.exe', PChar(ReplaysListBox.Items[ReplaysListBox.ItemIndex]), PChar(ExtractFilePath(Application.ExeName)), SW_SHOW);
end;

procedure TReplaysForm.DeleteButtonClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to delete ' + ReplaysListBox.Items[ReplaysListBox.ItemIndex] + '?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then Exit;
  DeleteFile(ExtractFilePath(Application.ExeName) + 'demos\' + ReplaysListBox.Items[ReplaysListBox.ItemIndex]);
  ReloadButton.OnClick(nil);

end;

end.
